package com.pdflib.cookbook.pcos.interactive;

import com.pdflib.IpCOS;

import com.pdflib.cookbook.pcos.pcos_cookbook_example;

/**
 * Retrieve bookmarks.
 * <p>
 * Required software: pCOS interface 3 (pCOS 3.x, PDFlib+PDI/PPS 7.x, TET 2.2,
 * PLOP 3.x) <br>
 * Required data: PDF document
 * 
 * @version $Id: bookmarks.java,v 1.7 2015/11/16 11:53:16 stm Exp $
 */
public class bookmarks extends pcos_cookbook_example {

    /* This is where the data files are. Adjust as necessary. */
    private final static String SEARCH_PATH = "../input";

    public void example_code(IpCOS p, int doc) throws Exception {

        System.out.println("File name: " + p.pcos_get_string(doc, "filename"));

        int bookmarkcount = (int) p.pcos_get_number(doc, "length:bookmarks");
        if (bookmarkcount == 0) {
            System.out.println("No bookmarks found");
        }
        else {
            System.out.println(bookmarkcount + " bookmarks found:");
            System.out.println();

            for (int i = 0; i < bookmarkcount; ++i) {
                int level = (int) p.pcos_get_number(doc, "bookmarks[" + i
                    + "]/level");
                int dest_page = (int) p.pcos_get_number(doc, "bookmarks[" + i
                    + "]/destpage");

                for (int j = 0; j < level * 4; j += 1) {
                    System.out.print(" ");
                }
                System.out.print(p.pcos_get_string(doc, "bookmarks[" + i
                    + "]/Title"));

                if (dest_page != -1) {
                    System.out.print(": page " + dest_page);
                }
                System.out.println();
            }
        }
    }

    public bookmarks(String[] argv, String readable_name, String search_path,
        String full_rcs_file_name, String revision) {
        super(argv, readable_name, search_path, full_rcs_file_name, revision);
    }

    public static void main(String argv[]) {
        bookmarks example = new bookmarks(argv, "Bookmarks", SEARCH_PATH,
            "$RCSfile: bookmarks.java,v $", "$Revision: 1.7 $");
        example.execute();
    }
}
